<!-- Spinner -->
<ngx-spinner [name]='"clusters"' [fullScreen]="true" bdColor="#f5f5f583" size="medium" type="ball-fussion" color="#EDAE49"></ngx-spinner>

<!-- Cluster Form -->
<div class="card" style="padding: 2%">
    <!-- Title -->
    <mat-label style="display: flex; justify-content: center; margin-top: 4%; margin-bottom: 4%">
        <mat-icon style="margin-right: 9px">monitor</mat-icon>
        <h1>Register Cluster</h1>
    </mat-label>

    <!-- Cluster Form -->
    <form [formGroup]="clusterForm" novalidate (ngSubmit)="submitForm(clusterForm.value)">
        <div style="display: flex; justify-content: center;" class="row mb-10">
            <div class="col-lg-12 col-xl-10">
                 <!-- Form First Row -->
                <div class="row">
                    <!-- Field: Cluster Name -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Cluster Name</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input required id="cluster_name" name="cluster_name"
                                formControlName="cluster_name" matInput type="text" placeholder="Type Cluster Name"/>
                            <mat-error *ngFor="let validation of incorrect_form_messages.cluster_name">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('cluster_name').hasError(validation.type) &&
                                    (clusterForm.get('cluster_name').dirty ||
                                    clusterForm.get('cluster_name').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>
                    </div>
                </div>
                <!-- Form Second Row -->
                <div class="row">
                    <!-- Field: CPUs -->
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">CPUs #</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input required id="cpus" name="cpus"
                                formControlName="cpus" matInput type="text" placeholder="Type # of CPUs"/>
                            <mat-error *ngFor="let validation of incorrect_form_messages.cpus">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('cpus').hasError(validation.type) &&
                                    (clusterForm.get('cpus').dirty ||
                                    clusterForm.get('cpus').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>
                    </div>
                    <!-- Field: Memory -->
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">Memory</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input required id="memory" name="memory"
                                formControlName="memory" matInput type="text" placeholder="Type Memory Size"/>
                            <mat-error *ngFor="let validation of incorrect_form_messages.memory">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('memory').hasError(validation.type) &&
                                    (clusterForm.get('memory').dirty ||
                                    clusterForm.get('memory').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>
                    </div>
                    <!-- Field: Storage -->
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">Storage</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input required id="storage" name="storage"
                                formControlName="storage" matInput type="text" placeholder="Type Storage Size"/>
                            <mat-error *ngFor="let validation of incorrect_form_messages.storage">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('storage').hasError(validation.type) &&
                                    (clusterForm.get('storage').dirty ||
                                    clusterForm.get('storage').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>
                    </div>
                </div>

                <!-- Form Third Row -->
                <div class="row">
                    <!-- Field: Availability -->
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">Availability %</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <mat-select required id="availability" name="availability"
                                        formControlName="availability" placeholder="Select Availability">
                                <!-- Define your options here -->
                                <mat-option *ngFor="let option of availability_options" [value]="option">
                                    {{ option }}
                                </mat-option>
                            </mat-select>
                            <mat-error *ngFor="let validation of incorrect_form_messages.availability">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('availability').hasError(validation.type) &&
                                    (clusterForm.get('availability').dirty ||
                                    clusterForm.get('availability').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>  
                    </div>
                    <!-- Field: Green Energy -->
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">Green Energy %</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <mat-select required id="green_energy" name="green_energy"
                                        formControlName="green_energy" placeholder="Select Green Energy %">
                                <!-- Define your options here -->
                                <mat-option *ngFor="let option of greenEnergy_options" [value]="option">
                                    {{ option }}
                                </mat-option>
                            </mat-select>
                            <mat-error *ngFor="let validation of incorrect_form_messages.green_energy">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('green_energy').hasError(validation.type) &&
                                    (clusterForm.get('green_energy').dirty ||
                                    clusterForm.get('green_energy').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>  
                    </div>
                    <!-- Field: Cost -->
                    <div class="col-lg-4">
                        <label class="col-lg-12 col-form-label text-lg">Cost</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <mat-select required id="cost" name="green_energy"
                                        formControlName="cost" placeholder="Select Cost">
                                <!-- Define your options here -->
                                <mat-option *ngFor="let option of cost_options" [value]="option">
                                    {{ option }}
                                </mat-option>
                            </mat-select>
                            <mat-error *ngFor="let validation of incorrect_form_messages.cost">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('cost').hasError(validation.type) &&
                                    (clusterForm.get('cost').dirty ||
                                    clusterForm.get('cost').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>  
                    </div>
                </div>

                <!-- Form Fourth Row -->
                <div class="row">
                    <!-- Field: cpu_base_rate -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">CPU Base Rate (in ms)</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input required id="cpu_base_rate" name="cpu_base_rate"
                                formControlName="cpu_base_rate" matInput type="text" placeholder="Type CPU Base Rate"/>
                            <mat-error *ngFor="let validation of incorrect_form_messages.cpus">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('cpu_base_rate').hasError(validation.type) &&
                                    (clusterForm.get('cpu_base_rate').dirty ||
                                    clusterForm.get('cpu_base_rate').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>
                    </div>
                    <!-- Field: Memory Base Rate -->
                    <div class="col-lg-6">
                        <label class="col-lg-12 col-form-label text-lg">Memory Base Rate (in MBs)</label><br>
                        <mat-form-field class="text-form-field" appearance="fill">
                            <input required id="memory_base_rate" name="memory_base_rate"
                                formControlName="memory_base_rate" matInput type="text" placeholder="Type Memory Base Rate"/>
                            <mat-error *ngFor="let validation of incorrect_form_messages.memory">
                                <span class="error-message" *ngIf="
                                    clusterForm.get('memory_base_rate').hasError(validation.type) &&
                                    (clusterForm.get('memory_base_rate').dirty ||
                                    clusterForm.get('memory_base_rate').touched)">
                                    {{ validation.message }}
                                </span>
                            </mat-error>
                        </mat-form-field><br>
                    </div>
                </div>

                
            </div>
        </div>
    </form>

    <div class="card-footer" style="display: flex; justify-content: end; background-color: white;">
        <div class="row">
            <div class="col-lg-22">
                <!-- Submit button -->
                <button mat-raised-button id="submit_button" class="btn-2"
                    type="submit" (click)="submitForm(clusterForm.value)">
                    <span class="indicator-label">
                    <a> Submit </a>
                    </span>
                </button>

                <!-- Reset button -->                    
                <button (click)="resetForm()" id="reset_button" mat-raised-button> 
                    Reset
                </button>

            </div>
        </div>
    </div>

</div>